-- Version 2.0
-- Author: Forbidenfate-Skywall

--====================INTERFACE====================
local frame = CreateFrame("Frame")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

--====================VARIABLES====================

-- Lust Buff Spells
local lustSpells = {
	[2825] = true, 		-- Bloodlust 30% Haste Buff => Sated Debuff (Castable by Horde Shaman)
	[32182] = true, 	-- Heroism 30% Haste Buff => Exhaustion Debuff (Castable by Alliance Shaman)
	[80353] = true, 	-- Time Warp 30% Haste Buff => Temporal Displacement Debuff (Castable by Mage)
	[90355] = true, 	-- Ancient Hysteria 30% Haste Buff => Sated Debuff (Castable by Hunter Core Hound Pet)
	[146555] = true, 	-- Drums of Rage 25% Haste Buff => Exhaustion Debuff (Castable by Anyone)
	[160452] = true, 	-- Netherwinds 30% Haste Buff => Fatigued Debuff (Castable by Hunter Nether Ray Pet)
	[178207] = true, 	-- Drums of Fury 25% Haste Buff => Exhaustion Debuff (Castable by Anyone)
	[230935] = true, 	-- Drums of the Mountain 25% Haste Buff => Exhaustion Debuff (Castable by Anyone)
}

-- Debuff Spells
local Debuffs = {
	57723, 				-- Exhaustion Debuff (Alliance) => 10 Minute Cooldown
	57724, 				-- Sated Debuff (Horde) => 10 Minute Cooldown
	80354, 				-- Temporal Displacement (Anyone) => 10 Minute Cooldown
	160455, 			-- Fatigued (Anyone) => 10 Minute Cooldown
}

--====================FUNCTIONS====================
frame:SetScript("OnEvent", function(self, event, ...)
	-- Script on Combat Log Event
	local _, event, _, _, sourceName, _, _, _, _, _, _, spellID, _ = ...
		if (event == "SPELL_CAST_SUCCESS" and GetNumGroupMembers() > 0 and lustSpells[spellID] and (UnitInParty(sourceName) or UnitInRaid(sourceName) or UnitInBattleground(sourceName))) then
			-- Initializations
			local isInstance, instanceType = IsInInstance()
			local chatType = "PARTY" -- Default Chat Type

			-- Check Lust Debuffs
			for _, dbID in ipairs(Debuffs) do
				if UnitDebuff(sourceName, GetSpellInfo(dbID)) and UnitDebuff("player", GetSpellInfo(dbID)) then
					return
				end
			end

			-- Get Chat Type
			if isInstance and instanceType == "pvp" then -- BGs
				chatType = "BATTLEGROUND"
			elseif isInstance and IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then -- Instance Specific Groups (Arenas/LFR/LFG)
				chatType = "INSTANCE_CHAT"
			elseif IsInRaid() then -- Raid Group
				chatType = "RAID"
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then -- Home-Realm Parties
				chatType = "PARTY"
			end

			-- Broadcast Group
			SendChatMessage("LustPopper: " .. UnitName(sourceName) .. " " .. GetSpellLink(spellID), chatType)
		end
	end
)